/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 package cours
{

	import starling.textures.TextureSmoothing;
	import flash.geom.Point;
	import flash.display.Bitmap;
	
	import starling.events.TouchPhase;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.textures.Texture;
	
	import starling.display.Image;
	import starling.textures.RenderTexture;
	import starling.display.Sprite;
	import starling.events.Event;


	public class GameDrawing extends Sprite
	{
		private var mRenderTexture : RenderTexture;
		
		private var oPinceau : Image;
		
		[Embed(source = "../../bin/assets/gomme.png")]
		private static const oGomme : Class;

		public function GameDrawing()
		{
			// attend la fin de l'initialisation de la scène
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(e : Event) : void
		{
			// création d'un bitmap à partir de l'image embed
			var brush : Bitmap = new oGomme();
			
			// création d'une texture à partir du bitmap
			var texture : Texture = Texture.fromBitmap(brush);
			
			// création de l'image à partir de la texture
			oPinceau = new Image(texture);
			
			// déplace le point d'origine 0,0
			oPinceau.pivotX = oPinceau.width >> 1;
			oPinceau.pivotY = oPinceau.height >> 1;
			
			oPinceau.smoothing = TextureSmoothing.TRILINEAR; // lissage de l'image
			oPinceau.scaleX = oPinceau.scaleY = 0.5;// scale - redimensionnement
			
			// création de la zone de dessin
			mRenderTexture = new RenderTexture(stage.stageWidth, stage.stageHeight);
			
			// création d'une image pour contenir la zone de dessin
			var canvas : Image = new Image(mRenderTexture);
			
			// affichage du canevas
			addChild(canvas);
			
			// écoute les évènements de la souris lorsqu'il y a un glissé du doigt sur l'écran du smartphone
			stage.addEventListener(TouchEvent.TOUCH, onTouch);
		}
		
		
		/**
		 * Appel lorsque l'utilisateur glisse ses doigts sur le smartphone.
		 * 
		 */
		private function onTouch(event : TouchEvent) : void
		{
			// récupérer les coordonnées des doigts sur l'écran
			var touches : Vector.<Touch> = event.getTouches(this);

			for each (var touch:Touch in touches)
			{
				// si clique ou touché de l'écran seulement, on dessine
				if (touch.phase == TouchPhase.HOVER || touch.phase == TouchPhase.ENDED)
					continue;

				// récupère la position pour chaque doigts
				var location : Point = touch.getLocation(this);

				// positionne le pinceau pour dessiner
				oPinceau.x = location.x;
				oPinceau.y = location.y;

				// dessine dans le caneva
				mRenderTexture.draw(oPinceau);
			}
		}
	}
}