/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 package cours
{

	import starling.core.Starling;
	import starling.animation.Tween;
	import starling.animation.Transitions;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.text.TextField;
	
	
	import flash.text.Font;
	
	
	import com.demonsters.debugger.MonsterDebugger;

	

	public class GameTween extends Sprite
	{
		[Embed(source='/../bin/fonts/angelina.ttf', embedAsCFF='false', fontName='Angelina')] 
		public static var Angelina:Class;  

		public function GameTween()
		{
			// attend la fin de l'initialisation de la scène
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(e : Event) : void
		{
			// création de la police
			var font:Font = new Angelina(); 

			// création d'un objet TextField
			var oText : TextField = new TextField(233, 233, "Voici du texte qui utilise une police Flash !!!", font.fontName, 38, 0x006f77, true);
			
			// positionne le texte sur la scène
			oText.x = 30;
			oText.y = 30;
			
			// affiche le texte
			addChild(oText);
			
			// création d'un objet tween
			var oTween : Tween = new Tween(oText, 4, Transitions.EASE_IN_OUT);// en secondes

			// indique la destination à l'objet
			oTween.moveTo(oText.x + 230, oText.y + 80);
			
			//oTween.fadeTo(0.3);// pour jouer sur la transparence alpha

			// écoute l'évènement start de l'objet Tween
			oTween.onStart = onStart;
			
			// écoute l'évènement progress de l'objet Tween
			oTween.onUpdate = onProgress;
			
			// écoute l'évènement complete de l'objet Tween
			oTween.onComplete = onComplete;
			
			// ajout à Starling
			Starling.juggler.add(oTween);
		}
		
		
		/**
		 * Appel par l'objet Tween.
		 * 
		 */
		private function onStart() : void
		{
			MonsterDebugger.trace(this, "tweening start");
		}
		
		/**
		 * Appel par l'objet Tween.
		 * 
		 */
		private function onProgress() : void
		{
			MonsterDebugger.trace(this, "tweening in progress");
		}
		
		/**
		 * Appel par l'objet Tween.
		 * 
		 */
		private function onComplete() : void
		{
			MonsterDebugger.trace(this, "tweening complete");
		}
	
	}
}